extern char *malloc(), *realloc();

# line 2 "parser.y"
# include	"common.h"
# include	"ast.h"
# include	"scanner.h"
# include       "micro.h"
AST_Ptr make_func();
void fix_error();

# define	Not_Implemented \
		mcprintf("Unimplemented feature\n",0,0)
Bool    need_clear = false;

#define YYSTYPE AST_Ptr
# define T_Id 257
# define T_Integer 258
# define T_String 259
# define T_Real 260
# define T_Boolean 261
# define CLEAR 262
# define T_Source 263
# define T_Gets 264
# define T_Where 265
# define T_St 266
# define T_Iff 267
# define T_Impl 268
# define T_Or 269
# define T_And 270
# define T_Not 271
# define T_In 272
# define T_Notin 273
# define T_Subset 274
# define T_Lt 275
# define T_Le 276
# define T_Eq 277
# define T_Ne 278
# define T_Gt 279
# define T_Ge 280
# define INFIX 281
# define T_Plus 282
# define T_Minus 283
# define T_With 284
# define T_Less 285
# define T_Times 286
# define T_Slash 287
# define T_Mod 288
# define T_Div 289
# define T_Exp 290
# define T_Insert 291
# define UNARY 292
# define CALL 293
# define T_Dotdot 294
# define T_Missing 295
# define T_Arrow 296
# define T_Take 297
# define T_To 298
# define T_Choose 299
# define T_Do 300
# define T_Else 301
# define T_Elseif 302
# define T_End 303
# define T_Exists 304
# define T_False 305
# define T_For 306
# define T_Forall 307
# define T_From 308
# define T_Fromb 309
# define T_Frome 310
# define T_Func 311
# define T_If 312
# define T_Local 313
# define T_Newat 314
# define T_Of 315
# define T_Om 316
# define T_Opt 317
# define T_Print 318
# define T_PrintF 319
# define T_Proc 320
# define T_Prog 321
# define T_Read 322
# define T_ReadF 323
# define T_Return 324
# define T_Then 325
# define T_True 326
# define T_Value 327
# define T_While 328
# define T_Write 329
# define T_Writeln 330
# define MAP 331
# define SELECTOR 332
# define ITERS 333
# define DEREF 334
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#ifndef YYSTYPE
#define YYSTYPE int
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256

# line 504 "parser.y"


void yyerror(i) char *i; {
}

void fix_error() 
	{     mcprintf("!Syntax error or clearing input at or before end of:",0,0);
	      Show_Error();

	      if( yyin==stdin ) {
		  mcprintf("\n!Enter '!clear'" ,0,0);
		  mcprintf("\n",0,0);
		  need_clear = true;
	      } else {
		  mcputc('\n');
		  yyclear();
                  ERROR;
	      }
	}

AST_Ptr make_func(fhead,dcls,stmts,endfunc) 
    AST_Ptr fhead,dcls,stmts,endfunc;
    { AST_Ptr result; 
      /* presumes |ptr| >= |int| and comparable */
      if( endfunc != (YYSTYPE)T_End && 
	   endfunc!= (YYSTYPE)ast_kind(fhead) ) {
	SYNTAX("Mis-matched 'end'");
      }
      func_level --;
      if( func_level==0 ) Source_Flush();

      result = New_AST(ast_kind(fhead), 
		   New_AST(T_Source,
			   (func_level==0 ? Func_List : Nil),
			   ast_2(fhead)), /* ARGS */
		   New_AST(0, dcls,      /* dcls */
			   New_AST(0,ast_1(fhead), /* First line */
				   stmts)) );
      if(func_level==0) {
	  Func_List = Nil;
      }
      return result;
    }
int yyexca[] ={
-1, 0,
	257, 16,
	258, 16,
	259, 16,
	260, 16,
	266, 16,
	271, 16,
	282, 16,
	283, 16,
	291, 16,
	64, 16,
	40, 16,
	123, 16,
	295, 16,
	297, 16,
	299, 16,
	304, 16,
	305, 16,
	306, 16,
	307, 16,
	311, 16,
	312, 16,
	314, 16,
	316, 16,
	318, 16,
	319, 16,
	320, 16,
	322, 16,
	323, 16,
	324, 16,
	326, 16,
	328, 16,
	329, 16,
	330, 16,
	91, 16,
	35, 16,
	-2, 0,
-1, 1,
	0, -1,
	-2, 0,
-1, 157,
	257, 16,
	258, 16,
	259, 16,
	260, 16,
	266, 16,
	271, 16,
	282, 16,
	283, 16,
	291, 16,
	64, 16,
	40, 16,
	123, 16,
	295, 16,
	297, 16,
	299, 16,
	304, 16,
	305, 16,
	306, 16,
	307, 16,
	311, 16,
	312, 16,
	314, 16,
	316, 16,
	318, 16,
	319, 16,
	320, 16,
	322, 16,
	323, 16,
	324, 16,
	326, 16,
	328, 16,
	329, 16,
	330, 16,
	91, 16,
	35, 16,
	-2, 0,
-1, 173,
	63, 0,
	-2, 82,
-1, 174,
	64, 0,
	-2, 83,
-1, 184,
	272, 0,
	273, 0,
	274, 0,
	275, 0,
	276, 0,
	277, 0,
	278, 0,
	279, 0,
	280, 0,
	-2, 93,
-1, 185,
	272, 0,
	273, 0,
	274, 0,
	275, 0,
	276, 0,
	277, 0,
	278, 0,
	279, 0,
	280, 0,
	-2, 94,
-1, 186,
	272, 0,
	273, 0,
	274, 0,
	275, 0,
	276, 0,
	277, 0,
	278, 0,
	279, 0,
	280, 0,
	-2, 95,
-1, 187,
	272, 0,
	273, 0,
	274, 0,
	275, 0,
	276, 0,
	277, 0,
	278, 0,
	279, 0,
	280, 0,
	-2, 96,
-1, 188,
	272, 0,
	273, 0,
	274, 0,
	275, 0,
	276, 0,
	277, 0,
	278, 0,
	279, 0,
	280, 0,
	-2, 97,
-1, 189,
	272, 0,
	273, 0,
	274, 0,
	275, 0,
	276, 0,
	277, 0,
	278, 0,
	279, 0,
	280, 0,
	-2, 98,
-1, 190,
	272, 0,
	273, 0,
	274, 0,
	275, 0,
	276, 0,
	277, 0,
	278, 0,
	279, 0,
	280, 0,
	-2, 99,
-1, 191,
	272, 0,
	273, 0,
	274, 0,
	275, 0,
	276, 0,
	277, 0,
	278, 0,
	279, 0,
	280, 0,
	-2, 100,
-1, 192,
	272, 0,
	273, 0,
	274, 0,
	275, 0,
	276, 0,
	277, 0,
	278, 0,
	279, 0,
	280, 0,
	-2, 101,
-1, 196,
	267, 0,
	-2, 105,
-1, 213,
	291, 0,
	-2, 107,
-1, 253,
	291, 0,
	-2, 106,
-1, 286,
	301, 13,
	302, 13,
	303, 13,
	-2, 16,
	};
# define YYNPROD 185
# define YYLAST 2178
int yyact[]={

    60,   326,   153,     4,   319,    54,    10,    20,   233,   242,
   337,   325,   333,    58,    55,    62,   154,    62,    62,    62,
   329,   328,   290,   309,   307,   295,   284,   255,   226,   163,
   160,    53,   160,   221,   144,   227,   100,   102,   102,   106,
   108,    99,   135,   136,   137,   225,   152,    71,   163,   149,
   150,   151,   224,   160,   217,   300,   235,     3,   257,    56,
    10,   239,   241,    70,    72,    73,   242,   160,     5,   169,
   170,   220,   140,   173,   174,   175,   176,   177,   178,   179,
   180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
   190,   191,   192,   193,   194,   195,   196,    39,    99,   198,
   204,   215,    35,     1,   158,   147,    99,    99,   212,   211,
   213,    99,   109,   172,   216,   208,   331,   101,   318,   289,
   220,    72,    73,   287,    98,   159,    38,   286,   256,    72,
    73,    73,   324,   148,    57,   160,     7,    67,   260,   288,
   218,   160,   317,   103,   243,   199,   254,   156,   259,   316,
   155,    51,   283,    36,   110,   105,   104,    59,    61,    63,
    34,   247,   248,    33,   249,   250,   139,   246,    99,   273,
   308,   306,   251,   252,    71,    64,    65,    66,   138,   145,
   146,    98,   310,    24,   332,    37,   327,   162,    22,    98,
    98,    72,    73,    21,    98,    19,   240,    11,   253,     6,
    10,   165,   166,   167,   168,   285,   262,    39,   234,   197,
   245,   264,    35,   206,     3,   141,   266,   222,   268,   294,
   270,   157,   272,     8,     2,   274,   275,     0,   277,     0,
   279,   280,   281,     0,     0,   276,    38,   278,   142,     0,
     0,   282,   202,   203,     0,     0,     0,     0,     0,     0,
     0,    98,     0,     0,     0,     0,     0,     0,   299,     0,
     0,   244,   302,    36,     0,   258,    97,     0,    95,    94,
    93,    92,     0,    89,    90,    91,    85,    87,    83,    84,
    86,    88,   210,    79,    80,    81,    82,    75,    76,    77,
    78,    74,    96,   161,   161,    37,     0,   320,   321,   219,
    99,   322,    68,   291,     0,   293,    39,    68,     0,     0,
     0,    35,   301,   200,     0,   263,   311,   330,    10,    10,
    26,    28,    27,    72,    73,     0,   338,     0,    52,   334,
    10,     0,     0,    41,   313,    38,   315,     0,   335,     0,
     0,     0,     0,   312,    42,    43,     0,   339,    74,    96,
   236,   238,   269,    40,     0,     0,   298,    25,     0,    49,
   223,    45,    36,     0,     0,     0,    44,    30,    47,    46,
    39,     0,     0,    54,    50,    35,    32,     0,    31,     0,
    15,    16,    55,    98,    13,    14,    12,     0,    29,     0,
    48,    17,    18,    97,    37,    95,    94,    93,    92,    38,
    89,    90,    91,    85,    87,    83,    84,    86,    88,   304,
    79,    80,    81,    82,    75,    76,    77,    78,    74,    96,
     0,     0,     0,     0,     0,     0,    36,     0,     0,    10,
    26,    28,    27,     0,     0,    39,   271,     0,    52,   292,
    35,     0,     0,    41,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   232,    42,    43,     0,     0,    37,     0,
     0,     0,     0,    40,    38,     0,   205,    25,     0,     0,
     0,    45,   200,     0,     0,     0,    44,    30,     0,    46,
     0,     0,     0,    54,    50,   314,    32,     0,    31,     0,
     0,    36,    55,     0,     0,     0,     0,     0,    29,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    39,     0,     0,     0,     0,   107,     0,     0,     0,
     0,     0,     0,    37,     0,     0,     0,     0,    10,    26,
    28,    27,     0,     0,     0,     0,     0,    52,     0,     0,
    38,     0,    41,     0,     0,     0,    75,    76,    77,    78,
    74,    96,     0,    42,    43,     0,     0,     0,     0,     0,
     0,     0,    40,     0,     0,     0,    25,    36,     0,     0,
    45,     0,     0,     0,     0,    44,    30,     0,    46,     0,
    99,     0,    54,    50,     0,    32,    71,    31,     0,     0,
     0,    55,    10,    26,    28,    27,     0,    29,     0,    37,
     0,    52,     0,    72,    73,     0,    41,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    42,    43,     0,
     0,     0,     0,     0,     0,     0,    40,     0,     0,     0,
    25,     0,     0,    68,    45,     0,     0,     0,     0,    44,
    30,     0,    46,     0,    99,     0,    54,    50,     0,    32,
    71,    31,     0,     0,     0,    55,     0,    10,    26,    28,
    27,    29,     0,    98,     0,     0,    52,    72,    73,     0,
     0,    41,     0,    99,     0,     0,     0,     0,     0,    71,
     0,     0,    42,    43,     0,     0,    99,     0,     0,     0,
     0,    40,    71,     0,     0,    25,    72,    73,     0,    45,
     0,     0,     0,     0,    44,    30,     0,    46,     0,    72,
    73,    54,    50,     0,    32,     0,    31,    99,   207,     0,
    55,   265,     0,    71,     0,     0,    29,    98,     0,     0,
     0,     0,     0,    10,    26,    28,    27,     0,     0,     0,
    72,    73,    52,     0,     0,     0,     0,    41,     0,    99,
     0,     0,     0,     0,     0,    71,    98,     0,    42,    43,
     0,     0,     0,     0,     0,     0,     0,    40,     0,    98,
    99,    25,    72,    73,     0,    45,     0,     0,     0,     0,
    44,    30,     0,    46,     0,     0,     0,    54,    50,     0,
    32,     0,    31,    72,    73,     0,    55,     0,     0,     0,
    98,     0,    29,     0,     0,    97,     0,    95,    94,    93,
    92,     0,    89,    90,    91,    85,    87,    83,    84,    86,
    88,     0,    79,    80,    81,    82,    75,    76,    77,    78,
    74,    96,    98,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   231,   230,
   229,     0,     0,    98,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    97,
     0,    95,    94,    93,    92,     0,    89,    90,    91,    85,
    87,    83,    84,    86,    88,     0,    79,    80,    81,    82,
    75,    76,    77,    78,    74,    96,     0,     0,    97,     0,
    95,    94,    93,    92,   228,    89,    90,    91,    85,    87,
    83,    84,    86,    88,     0,    79,    80,    81,    82,    75,
    76,    77,    78,    74,    96,     0,     0,   261,    79,    80,
    81,    82,    75,    76,    77,    78,    74,    96,     0,     0,
     0,     0,    97,     0,    95,    94,    93,    92,     0,    89,
    90,    91,    85,    87,    83,    84,    86,    88,     0,    79,
    80,    81,    82,    75,    76,    77,    78,    74,    96,     0,
     0,     0,     0,     0,    97,   336,    95,    94,    93,    92,
     0,    89,    90,    91,    85,    87,    83,    84,    86,    88,
     0,    79,    80,    81,    82,    75,    76,    77,    78,    74,
    96,    99,   323,     0,     0,     0,     0,    71,     0,     0,
     0,     0,    79,    80,    81,    82,    75,    76,    77,    78,
    74,    96,     0,     0,    72,    73,     0,     0,    99,   305,
     0,     0,     0,     0,    71,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    72,    73,     0,     0,    99,   303,     0,     0,     0,
     0,    71,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    72,    73,
     0,     0,    99,   297,    98,     0,     0,     0,    71,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    72,    73,     0,     0,    99,
     0,    98,     0,     0,     0,    71,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    72,    73,     0,     0,    99,   267,    98,     0,
     0,     0,    71,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    72,
    73,     0,     0,     0,     0,    98,     0,     0,     0,     0,
     0,    99,     0,     0,     0,     0,     0,    71,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    98,     0,    72,    73,     0,     0,    99,   207,
     0,     0,     0,     0,    71,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    98,
     0,    72,    73,     0,     0,     0,    97,     0,    95,    94,
    93,    92,     0,    89,    90,    91,    85,    87,    83,    84,
    86,    88,     0,    79,    80,    81,    82,    75,    76,    77,
    78,    74,    96,    97,    98,    95,    94,    93,    92,     0,
    89,    90,    91,    85,    87,    83,    84,    86,    88,     0,
    79,    80,    81,    82,    75,    76,    77,    78,    74,    96,
    97,    98,    95,    94,    93,    92,     0,    89,    90,    91,
    85,    87,    83,    84,    86,    88,     0,    79,    80,    81,
    82,    75,    76,    77,    78,    74,    96,    97,     0,    95,
    94,    93,    92,     0,    89,    90,    91,    85,    87,    83,
    84,    86,    88,     0,    79,    80,    81,    82,    75,    76,
    77,    78,    74,    96,    97,   296,    95,    94,    93,    92,
     0,    89,    90,    91,    85,    87,    83,    84,    86,    88,
     0,    79,    80,    81,    82,    75,    76,    77,    78,    74,
    96,    97,     0,    95,    94,    93,    92,     0,    89,    90,
    91,    85,    87,    83,    84,    86,    88,     0,    79,    80,
    81,    82,    75,    76,    77,    78,    74,    96,     0,     0,
     0,     0,     0,     0,     0,     0,    97,   209,    95,    94,
    93,    92,     0,    89,    90,    91,    85,    87,    83,    84,
    86,    88,     0,    79,    80,    81,    82,    75,    76,    77,
    78,    74,    96,    97,     0,    95,    94,    93,    92,     0,
    89,    90,    91,    85,    87,    83,    84,    86,    88,     0,
    79,    80,    81,    82,    75,    76,    77,    78,    74,    96,
    99,     0,     0,     0,     0,     0,    71,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    72,    73,     0,     0,     0,    99,     0,
     0,     0,     0,     0,    71,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    72,    73,     0,     0,    99,     0,     0,     0,     0,
     0,    71,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    72,    73,
    99,     0,     0,    98,     0,     0,    71,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    72,    73,     0,    99,     0,     0,     0,
     0,    98,    71,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    72,
    73,    99,     0,     0,     0,     0,     0,    71,    98,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    72,    73,     0,     0,    99,     0,
     0,     0,     0,    98,    71,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    72,    73,     0,     0,     0,    99,     0,     0,    98,
     0,     0,    71,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    72,
    73,     0,     0,     0,    98,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    97,   164,    95,    94,    93,
    92,     0,    89,    90,    91,    85,    87,    83,    84,    86,
    88,    98,    79,    80,    81,    82,    75,    76,    77,    78,
    74,    96,    69,    97,     0,    95,    94,    93,    92,     0,
    89,    90,    91,    85,    87,    83,    84,    86,    88,    98,
    79,    80,    81,    82,    75,    76,    77,    78,    74,    96,
    97,     0,    95,    94,    93,    92,     0,    89,    90,    91,
    85,    87,    83,    84,    86,    88,     0,    79,    80,    81,
    82,    75,    76,    77,    78,    74,    96,    95,    94,    93,
    92,     0,    89,    90,    91,    85,    87,    83,    84,    86,
    88,     0,    79,    80,    81,    82,    75,    76,    77,    78,
    74,    96,     0,     0,    94,    93,    92,     0,    89,    90,
    91,    85,    87,    83,    84,    86,    88,     0,    79,    80,
    81,    82,    75,    76,    77,    78,    74,    96,     0,     0,
    93,    92,     0,    89,    90,    91,    85,    87,    83,    84,
    86,    88,     0,    79,    80,    81,    82,    75,    76,    77,
    78,    74,    96,   113,     0,     0,     0,     0,    92,   112,
    89,    90,    91,    85,    87,    83,    84,    86,    88,     0,
    79,    80,    81,    82,    75,    76,    77,    78,    74,    96,
     0,     0,     0,     0,     0,     0,     0,     0,    89,    90,
    91,    85,    87,    83,    84,    86,    88,     0,    79,    80,
    81,    82,    75,    76,    77,    78,    74,    96,    23,     0,
     0,     0,     0,     0,     9,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   111,
     0,     0,     0,   143,   143,   143,   143,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   171,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   111,   201,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   214,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   143,     0,     0,     0,     0,     0,     0,
     0,     0,   237,   237,   237,     0,     0,     0,     0,     0,
    10,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   134,   133,   132,     0,   129,   130,   131,   125,   127,
   123,   124,   126,   128,     0,   119,   120,   121,   122,   115,
   116,   117,   118,   114,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   143,     0,
     0,     0,     0,     0,     0,     0,     0,   143,     0,   143,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   237,   237,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   201,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   237 };
int yypact[]={

  -253, -1000, -1000,    77, -1000,  -197,    62, -1000,  -203,    75,
 -1000, -1000,   400,   400,   400,   400,   400,   400,   335, -1000,
  1438, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000,   400,   400,   400,   476,   400,
  1793,   400,   400,   400,   -57,   -57,   -57,   -57,   400,   400,
   400,  -311, -1000, -1000, -1000, -1000, -1000,  -311,  1465,   -14,
  1465,   -15,  1410,     9,     4,     4,     4, -1000,   400,   400,
 -1000,    73,   400,   400,   400,   400,   400,   400,   400,   400,
   400,   400,   400,   400,   400,   400,   400,   400,   400,   400,
   400,   400,   400,   400,   400,   400,  1793,   -57,   400,   172,
  1158,    22,  1131,   -12, -1000,   -16,    71,   400,    71,   400,
 -1000, -1000,    61,   400, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000,  1596,    71,    71,  -212,    96,
    27,  -244, -1000, -1000,   -57,  -214,  -221,  -272,  -231,   604,
   540,   128, -1000,  -197,  -197,  -251,   104,  -253, -1000, -1000,
   400,   400, -1000,   400,   400, -1000, -1000, -1000, -1000,  1465,
  1465,   400,   400,    67,    71,    58,    58,    58,    58,    58,
   260,   260,   260,   260,   646,   646,   646,   646,   646,   646,
   646,   646,   646,  1596,  1568,  1541,  1516,   400,  -276,    69,
  -206,    71,    23,    97,   633,   400, -1000, -1000, -1000,   -57,
   400, -1000,   677,    66, -1000,   400,  1096,   400,   -57,   400,
   -57,   400,    76, -1000,   400,   400, -1000,   400, -1000,   400,
   400,   400, -1000,  -277,    68, -1000,    64,    95,    60,  -274,
  -308, -1000,  -197,  -251, -1000,  -278, -1000,  1465,  1465,  1069,
  1465,   730,  1042,    66, -1000, -1000,   -57,   400,  -209, -1000,
 -1000,   271,  1015, -1000,  1465,   400,   988, -1000,  1490, -1000,
  1465, -1000,  1465, -1000,  1490,  1490,  -279,  1465,  -280,  1465,
  1465,  1465, -1000, -1000,  -306, -1000, -1000,  -311,  -197,  -311,
 -1000, -1000, -1000,   101,    59,  -317,   400,   400, -1000,  1465,
   400, -1000,   961, -1000,    91, -1000, -1000,  -295, -1000,  -327,
  -281, -1000, -1000, -1000, -1000, -1000,   400,    57, -1000, -1000,
  1465,   730,  1465, -1000, -1000, -1000, -1000,  -291,   400, -1000,
   709, -1000, -1000,  -302,     1, -1000, -1000, -1000, -1000, -1000 };
int yypgo[]={

     0,   103,  1888,   224,    56,   223,   221,   219,    46,   210,
     8,   208,   205,   199,   197,   125,     0,   137,   143,   158,
   195,   193,   188,   186,   184,   183,   182,   171,   170,   105,
   133,   166,    72,   215,    63,   163,   160,   117,   112,   156,
   154,    31,   152,   151,   150,    61,   149,   196,    62,   147,
   146,    99,   145 };
int yyr1[]={

     0,     2,     1,     1,     5,     6,     1,     7,     7,     3,
     9,    10,    12,    12,    11,    11,    13,     4,    15,    15,
    17,    17,    14,    14,    14,    14,    14,    14,    14,    14,
    14,    14,    14,    14,    14,    23,    23,    24,    24,    25,
    26,    26,    27,    27,    28,    28,    21,    21,    29,    29,
    30,    30,    31,    31,    34,    34,    34,    34,    34,    34,
    20,    16,    16,    16,    16,    16,    16,    16,    16,    16,
    16,    16,    16,    16,    16,    16,    16,    16,    16,    16,
    16,    16,    16,    16,    16,    16,    16,    16,    16,    16,
    16,    16,    16,    16,    16,    16,    16,    16,    16,    16,
    16,    16,    16,    16,    16,    16,    16,    16,    16,    16,
    16,    16,    16,    16,    18,    18,    19,    19,    19,    19,
    39,    22,    22,    22,    37,    37,    37,    37,    38,    38,
    38,    38,    38,    40,    40,    40,    40,    40,    40,    40,
    40,    40,    40,    40,    40,    40,    40,    40,    40,    40,
    40,    40,    40,    40,    41,    41,    42,    42,    35,    44,
    46,    35,    45,    45,    49,    43,    48,    48,     8,     8,
     8,    47,    47,    50,    36,    51,    51,    51,    52,    52,
    33,    33,    33,    32,    32 };
int yyr2[]={

     0,     3,     3,     5,     1,     1,    11,     2,     4,    15,
     2,     5,     0,     2,     7,     3,     1,     5,     1,     5,
     1,     5,     3,     5,     7,     7,     7,     7,     7,     7,
     5,     2,     3,     2,     2,     5,     1,     2,     4,    15,
    11,     1,     2,     4,     2,     4,    11,    11,     3,     7,
     7,     3,     7,     7,     7,     7,     9,     9,    11,     5,
     7,     2,     2,     3,     3,     3,     3,     3,     3,     3,
     3,     2,     2,     7,     7,     7,     5,    13,     5,     5,
     9,    13,     7,     7,     7,     7,     7,     7,     7,     7,
     7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
     7,     7,     7,     7,     7,     7,     9,     7,     5,     5,
     5,     9,     9,     9,     3,     7,     3,     7,     7,    11,
     7,     9,     9,     9,     1,     7,     2,     2,     3,     2,
     5,     7,     9,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     3,     3,     3,     5,     9,     1,
     1,    15,     5,     3,     1,    13,     1,     5,     1,     9,
     9,     3,     7,     2,     9,     3,     5,     7,     7,     9,
     3,     2,     7,     3,     7 };
int yychk[]={

 -1000,    -1,    -3,    -4,   256,   321,   -13,    59,    -5,    -2,
   257,   -14,   324,   322,   323,   318,   319,   329,   330,   -20,
   -16,   -21,   -22,    -2,   -25,   295,   258,   260,   259,   326,
   305,   316,   314,   -35,   -36,    40,    91,   123,    64,    35,
   291,   271,   282,   283,   304,   299,   307,   306,   328,   297,
   312,   -43,   266,   -41,   311,   320,   262,    59,   -16,   -18,
   -16,   -19,   -16,   -18,   -19,   -19,   -19,   -17,   298,   264,
   -34,    46,    63,    64,   290,   286,   287,   288,   289,   282,
   283,   284,   285,   277,   278,   275,   279,   276,   280,   272,
   273,   274,   270,   269,   268,   267,   291,   265,   123,    40,
   -16,   -37,   -16,   -18,   -39,   -37,   -16,    40,   -16,   -38,
   -40,    -2,    46,    40,   290,   286,   287,   288,   289,   282,
   283,   284,   285,   277,   278,   275,   279,   276,   280,   272,
   273,   274,   270,   269,   268,   -16,   -16,   -16,   -30,   -31,
   -32,   -33,   295,    -2,    91,   -30,   -30,   -29,   -30,   -16,
   -16,   -16,    -8,   313,   327,   -44,   -49,    -6,    -8,   -15,
    44,   308,   -15,    44,   266,   -17,   -17,   -17,   -17,   -16,
   -16,    -2,    40,   -16,   -16,   -16,   -16,   -16,   -16,   -16,
   -16,   -16,   -16,   -16,   -16,   -16,   -16,   -16,   -16,   -16,
   -16,   -16,   -16,   -16,   -16,   -16,   -16,   -38,   -51,   -52,
   -33,    -2,   -18,   -18,   -16,   294,    41,    41,    93,   266,
   294,   125,   -16,   -16,    -2,    40,   -16,   266,    44,   272,
    44,   277,   -32,   -33,   266,   266,   300,   266,   300,   310,
   309,   308,   325,   -10,   -11,    -4,   -47,    -2,   -47,   -45,
   -47,   -48,   317,    40,    -1,    -9,   -10,   -16,   -16,   -16,
   -16,   -16,   -16,   -16,   -50,   303,    59,   264,   -34,   125,
    41,   294,   -16,   -29,   -16,    44,   -16,    41,   -16,   -30,
   -16,   -33,   -16,    93,   -16,   -16,   -10,   -16,   -10,   -16,
   -16,   -16,   -10,   -42,   303,   -12,    59,    59,    44,    59,
   296,   -48,   -47,   -45,    -7,   303,   266,    41,   -51,   -16,
   264,    41,   -16,    41,   -18,    41,   -27,   303,   -28,   303,
   -26,   -41,    -4,    -8,   -47,    -8,   -46,    41,    59,   321,
   -16,   -16,   -16,    41,    41,   306,   328,   -23,   302,   301,
   -16,    59,   -24,   303,   -16,   -10,   266,   312,   325,   -10 };
int yydef[]={

    -2,    -2,     2,     0,     4,     0,     0,     3,     0,     0,
     1,    17,    22,     0,     0,     0,     0,     0,    20,    31,
    32,    33,    34,    61,    62,    63,    64,    65,    66,    67,
    68,    69,    70,    71,    72,     0,   124,   124,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   168,   159,   164,   154,   155,     5,   168,    23,    18,
   114,    18,   116,    20,    20,    20,    20,    30,     0,     0,
    79,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   114,   126,   127,     0,    76,     0,    78,     0,
   128,   129,     0,     0,   133,   134,   135,   136,   137,   138,
   139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
   149,   150,   151,   152,   153,   108,   109,   110,     0,    51,
     0,   183,   180,   181,     0,     0,     0,     0,    48,     0,
     0,     0,    16,     0,     0,   166,     0,    -2,    16,    24,
     0,     0,    25,     0,     0,    26,    27,    28,    29,    21,
    60,     0,     0,    -2,    -2,    84,    85,    86,    87,    88,
    89,    90,    91,    92,    -2,    -2,    -2,    -2,    -2,    -2,
    -2,    -2,    -2,   102,   103,   104,    -2,     0,     0,   175,
     0,   181,     0,     0,   114,     0,    59,    73,    74,     0,
     0,    75,     0,    -2,   130,     0,     0,     0,     0,     0,
     0,     0,     0,   183,     0,     0,    16,     0,    16,     0,
     0,     0,    16,     0,    12,    15,     0,   171,     0,     0,
   166,   163,     0,   166,     6,     0,    10,   115,    19,   118,
   117,    80,     0,    -2,   174,   173,   176,     0,     0,    54,
    55,     0,     0,   125,   120,     0,     0,   131,   111,    50,
    52,   184,    53,   182,   112,   113,     0,    49,     0,   121,
   122,   123,    41,   158,   156,    11,    -2,   168,     0,   168,
   160,   162,   167,     0,     0,     7,     0,     0,   177,   178,
     0,    56,     0,    57,     0,   132,    46,    42,    47,    44,
    36,   157,    14,   169,   172,   170,     0,     0,     9,     8,
   119,    81,   179,    58,    77,    43,    45,     0,     0,    16,
     0,   165,    39,    37,     0,    35,   161,    38,    16,    40 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"T_Id",	257,
	"T_Integer",	258,
	"T_String",	259,
	"T_Real",	260,
	"T_Boolean",	261,
	"CLEAR",	262,
	"T_Source",	263,
	"T_Gets",	264,
	"T_Where",	265,
	"T_St",	266,
	"T_Iff",	267,
	"T_Impl",	268,
	"T_Or",	269,
	"T_And",	270,
	"T_Not",	271,
	"T_In",	272,
	"T_Notin",	273,
	"T_Subset",	274,
	"T_Lt",	275,
	"T_Le",	276,
	"T_Eq",	277,
	"T_Ne",	278,
	"T_Gt",	279,
	"T_Ge",	280,
	"INFIX",	281,
	".",	46,
	"T_Plus",	282,
	"T_Minus",	283,
	"T_With",	284,
	"T_Less",	285,
	"T_Times",	286,
	"T_Slash",	287,
	"T_Mod",	288,
	"T_Div",	289,
	"T_Exp",	290,
	"T_Insert",	291,
	"?",	63,
	"@",	64,
	"UNARY",	292,
	"CALL",	293,
	"(",	40,
	"{",	123,
	"T_Dotdot",	294,
	"T_Missing",	295,
	"T_Arrow",	296,
	"T_Take",	297,
	"T_To",	298,
	"T_Choose",	299,
	"T_Do",	300,
	"T_Else",	301,
	"T_Elseif",	302,
	"T_End",	303,
	"T_Exists",	304,
	"T_False",	305,
	"T_For",	306,
	"T_Forall",	307,
	"T_From",	308,
	"T_Fromb",	309,
	"T_Frome",	310,
	"T_Func",	311,
	"T_If",	312,
	"T_Local",	313,
	"T_Newat",	314,
	"T_Of",	315,
	"T_Om",	316,
	"T_Opt",	317,
	"T_Print",	318,
	"T_PrintF",	319,
	"T_Proc",	320,
	"T_Prog",	321,
	"T_Read",	322,
	"T_ReadF",	323,
	"T_Return",	324,
	"T_Then",	325,
	"T_True",	326,
	"T_Value",	327,
	"T_While",	328,
	"T_Write",	329,
	"T_Writeln",	330,
	"MAP",	331,
	"SELECTOR",	332,
	"ITERS",	333,
	"DEREF",	334,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"id : T_Id",
	"program : simple.program",
	"program : stmt ';'",
	"program : error",
	"program : error CLEAR",
	"program : error CLEAR program",
	"end.prog : T_End",
	"end.prog : T_End T_Prog",
	"simple.program : T_Prog id ';' dcls body end.prog ';'",
	"body : stmts",
	"stmts : stmt.list opt.semi",
	"opt.semi : /* empty */",
	"opt.semi : ';'",
	"stmt.list : stmt.list ';' stmt",
	"stmt.list : stmt",
	"stmt : /* empty */",
	"stmt : real.stmt",
	"opt.from : /* empty */",
	"opt.from : T_From expr",
	"opt.to : /* empty */",
	"opt.to : T_To expr",
	"real.stmt : T_Return",
	"real.stmt : T_Return expr",
	"real.stmt : T_Read expr.list opt.from",
	"real.stmt : T_ReadF pair.list opt.from",
	"real.stmt : T_Print expr.list opt.to",
	"real.stmt : T_PrintF pair.list opt.to",
	"real.stmt : T_Write pair.list opt.to",
	"real.stmt : T_Writeln pair.list opt.to",
	"real.stmt : T_Writeln opt.to",
	"real.stmt : assignment",
	"real.stmt : expr",
	"real.stmt : loop.stmt",
	"real.stmt : from.stmt",
	"else.part : T_Else stmts",
	"else.part : /* empty */",
	"end.if : T_End",
	"end.if : T_End T_If",
	"if.stmt : T_If expr T_Then stmts else.ifs else.part end.if",
	"else.ifs : else.ifs T_Elseif expr T_Then stmts",
	"else.ifs : /* empty */",
	"end.for : T_End",
	"end.for : T_End T_For",
	"end.while : T_End",
	"end.while : T_End T_While",
	"loop.stmt : T_For iterator T_Do stmts end.for",
	"loop.stmt : T_While expr T_Do stmts end.while",
	"iterator : iter.list",
	"iterator : iter.list T_St expr",
	"iter.list : simple.iterator ',' iter.list",
	"iter.list : simple.iterator",
	"simple.iterator : bound.list T_In expr",
	"simple.iterator : bound T_Eq expr",
	"selector : '{' expr.list '}'",
	"selector : '(' expr.list ')'",
	"selector : '(' expr T_Dotdot ')'",
	"selector : '(' T_Dotdot expr ')'",
	"selector : '(' expr T_Dotdot expr ')'",
	"selector : '(' ')'",
	"assignment : expr T_Gets expr",
	"expr : id",
	"expr : if.stmt",
	"expr : T_Missing",
	"expr : T_Integer",
	"expr : T_Real",
	"expr : T_String",
	"expr : T_True",
	"expr : T_False",
	"expr : T_Om",
	"expr : T_Newat",
	"expr : func.const",
	"expr : where.clause",
	"expr : '(' expr ')'",
	"expr : '[' former ']'",
	"expr : '{' former '}'",
	"expr : '@' expr",
	"expr : '@' '(' expr ',' expr.list ')'",
	"expr : '#' expr",
	"expr : expr selector",
	"expr : expr '.' id expr",
	"expr : expr '.' '(' expr ')' expr",
	"expr : expr '?' expr",
	"expr : expr '@' expr",
	"expr : expr T_Exp expr",
	"expr : expr T_Times expr",
	"expr : expr T_Slash expr",
	"expr : expr T_Mod expr",
	"expr : expr T_Div expr",
	"expr : expr T_Plus expr",
	"expr : expr T_Minus expr",
	"expr : expr T_With expr",
	"expr : expr T_Less expr",
	"expr : expr T_Eq expr",
	"expr : expr T_Ne expr",
	"expr : expr T_Lt expr",
	"expr : expr T_Gt expr",
	"expr : expr T_Le expr",
	"expr : expr T_Ge expr",
	"expr : expr T_In expr",
	"expr : expr T_Notin expr",
	"expr : expr T_Subset expr",
	"expr : expr T_And expr",
	"expr : expr T_Or expr",
	"expr : expr T_Impl expr",
	"expr : expr T_Iff expr",
	"expr : expr T_Insert binop expr",
	"expr : T_Insert binop expr",
	"expr : T_Not expr",
	"expr : T_Plus expr",
	"expr : T_Minus expr",
	"expr : T_Exists iter.list T_St expr",
	"expr : T_Choose iter.list T_St expr",
	"expr : T_Forall iter.list T_St expr",
	"expr.list : expr",
	"expr.list : expr.list ',' expr",
	"pair.list : expr",
	"pair.list : expr T_St expr",
	"pair.list : pair.list ',' expr",
	"pair.list : pair.list ',' expr T_St expr",
	"counted : expr.list T_Dotdot expr",
	"from.stmt : T_Take expr T_Frome expr",
	"from.stmt : T_Take expr T_Fromb expr",
	"from.stmt : T_Take expr T_From expr",
	"former : /* empty */",
	"former : expr T_St iterator",
	"former : expr.list",
	"former : counted",
	"binop : binop.short",
	"binop : id",
	"binop : '.' id",
	"binop : '(' expr ')'",
	"binop : '.' '(' expr ')'",
	"binop.short : T_Exp",
	"binop.short : T_Times",
	"binop.short : T_Slash",
	"binop.short : T_Mod",
	"binop.short : T_Div",
	"binop.short : T_Plus",
	"binop.short : T_Minus",
	"binop.short : T_With",
	"binop.short : T_Less",
	"binop.short : T_Eq",
	"binop.short : T_Ne",
	"binop.short : T_Lt",
	"binop.short : T_Gt",
	"binop.short : T_Le",
	"binop.short : T_Ge",
	"binop.short : T_In",
	"binop.short : T_Notin",
	"binop.short : T_Subset",
	"binop.short : T_And",
	"binop.short : T_Or",
	"binop.short : T_Impl",
	"t_func : T_Func",
	"t_func : T_Proc",
	"end.func : T_End",
	"end.func : T_End t_func",
	"func.const : func.head dcls stmts end.func",
	"func.const : T_St",
	"func.const : T_St args T_Arrow",
	"func.const : T_St args T_Arrow expr T_St",
	"args : id.list opt.part",
	"args : opt.part",
	"func.head : t_func",
	"func.head : t_func '(' args ')' ';'",
	"opt.part : /* empty */",
	"opt.part : T_Opt id.list",
	"dcls : /* empty */",
	"dcls : T_Local id.list ';' dcls",
	"dcls : T_Value id.list ';' dcls",
	"id.list : id",
	"id.list : id ',' id.list",
	"end.where : T_End",
	"where.clause : expr T_Where defns end.where",
	"defns : defn",
	"defns : defn ';'",
	"defns : defn ';' defns",
	"defn : bound T_Gets expr",
	"defn : id selector T_Gets expr",
	"bound : T_Missing",
	"bound : id",
	"bound : '[' bound.list ']'",
	"bound.list : bound",
	"bound.list : bound.list ',' bound",
};
#endif /* YYDEBUG */
#line 1 "/usr/lib/yaccpar"
/*	@(#)yaccpar 1.10 89/04/04 SMI; from S5R3 1.10	*/

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	{ free(yys); free(yyv); return(0); }
#define YYABORT		{ free(yys); free(yyv); return(1); }
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-1000)

/*
** static variables used by the parser
*/
static YYSTYPE *yyv;			/* value stack */
static int *yys;			/* state stack */

static YYSTYPE *yypv;			/* top of value stack */
static int *yyps;			/* top of state stack */

static int yystate;			/* current state */
static int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */

int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */


/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */
	unsigned yymaxdepth = YYMAXDEPTH;

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yyv = (YYSTYPE*)malloc(yymaxdepth*sizeof(YYSTYPE));
	yys = (int*)malloc(yymaxdepth*sizeof(int));
	if (!yyv || !yys)
	{
		yyerror( "out of memory" );
		return(1);
	}
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			(void)printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			yymaxdepth += YYMAXDEPTH;
			yyv = (YYSTYPE*)realloc((char*)yyv,
				yymaxdepth * sizeof(YYSTYPE));
			yys = (int*)realloc((char*)yys,
				yymaxdepth * sizeof(int));
			if (!yyv || !yys)
			{
				yyerror( "yacc stack overflow" );
				return(1);
			}
			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			(void)printf( "Received token " );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				(void)printf( "Received token " );
				if ( yychar == 0 )
					(void)printf( "end-of-file\n" );
				else if ( yychar < 0 )
					(void)printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					(void)printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						(void)printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					(void)printf( "Error recovery discards " );
					if ( yychar == 0 )
						(void)printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						(void)printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						(void)printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			(void)printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 1:
# line 56 "parser.y"
{yyval = New_AST(T_Id, (AST_Ptr)str((char*)yypvt[-0]), ANULL);} break;
case 2:
# line 60 "parser.y"
{parsed = yypvt[-0]; return  0;} break;
case 3:
# line 61 "parser.y"
{parsed = yypvt[-1]; return  0;} break;
case 4:
# line 63 "parser.y"
{ fix_error(); } break;
case 5:
# line 64 "parser.y"
{ need_clear = false; } break;
case 6:
# line 66 "parser.y"
{ yyval = yypvt[-0]; } break;
case 9:
# line 77 "parser.y"
{yyval = New_AST(T_Prog, yypvt[-3], yypvt[-2]);} break;
case 11:
# line 85 "parser.y"
{yyval = Rev_Seq(yypvt[-1]);} break;
case 14:
# line 91 "parser.y"
{yyval = New_AST(0, yypvt[-0], yypvt[-2]);} break;
case 15:
# line 92 "parser.y"
{yyval = New_AST(0, yypvt[-0], ANULL);} break;
case 16:
# line 95 "parser.y"
{ yyval = New_AST(T_Source, Source_List,ANULL); Source_List = yyval; } break;
case 17:
# line 97 "parser.y"
{ yyval = yypvt[-1]; ast_2(yypvt[-1])= yypvt[-0];} break;
case 18:
# line 103 "parser.y"
{yyval = ANULL;} break;
case 19:
# line 104 "parser.y"
{ yyval=yypvt[-0]; } break;
case 20:
# line 107 "parser.y"
{yyval = ANULL;} break;
case 21:
# line 108 "parser.y"
{ yyval=yypvt[-0]; } break;
case 22:
# line 114 "parser.y"
{yyval = New_AST(T_Return,ANULL,ANULL);} break;
case 23:
# line 115 "parser.y"
{yyval = New_AST(T_Return,yypvt[-0],ANULL);} break;
case 24:
# line 116 "parser.y"
{yyval = New_AST(T_Read, yypvt[-1], yypvt[-0]);} break;
case 25:
# line 117 "parser.y"
{yyval = New_AST(T_ReadF, yypvt[-1], yypvt[-0]);} break;
case 26:
# line 118 "parser.y"
{yyval = New_AST(T_Print, yypvt[-1], yypvt[-0]);} break;
case 27:
# line 119 "parser.y"
{yyval = New_AST(T_PrintF, yypvt[-1], yypvt[-0]);} break;
case 28:
# line 120 "parser.y"
{yyval = New_AST(T_PrintF, yypvt[-1], yypvt[-0]);} break;
case 29:
# line 122 "parser.y"
{yyval = New_AST(T_PrintF, 
			  New_AST(0,
				  New_AST(T_Om,ANULL,ANULL),
				  New_AST(0, New_AST(T_String,
						     (AST_Ptr)str("\n"),ANULL),
					  yypvt[-1])),
			  yypvt[-0]);} break;
case 30:
# line 130 "parser.y"
{yyval = New_AST(T_PrintF, 
			  New_AST(0,
				  New_AST(T_Om,ANULL,ANULL),
				  New_AST(0, New_AST(T_String,
						     (AST_Ptr)str("\n"),ANULL),
					  ANULL)),
			  yypvt[-0]);} break;
case 32:
# line 138 "parser.y"
{yyval = New_AST(CALL, yypvt[-0], ANULL); } break;
case 35:
# line 145 "parser.y"
{yyval = yypvt[-0];} break;
case 36:
# line 146 "parser.y"
{yyval = ANULL; } break;
case 39:
# line 156 "parser.y"
{yyval = New_AST(T_If, New_AST(0, yypvt[-5], yypvt[-3]),
			    New_AST(0, Rev_Seq(yypvt[-2]), yypvt[-1]) ); } break;
case 40:
# line 162 "parser.y"
{yyval = New_AST(T_Elseif, New_AST(0, yypvt[-2], yypvt[-0]),
				yypvt[-4]); } break;
case 41:
# line 165 "parser.y"
{yyval = ANULL; } break;
case 46:
# line 180 "parser.y"
{yyval = New_AST(T_For, yypvt[-3], yypvt[-1]);} break;
case 47:
# line 182 "parser.y"
{yyval = New_AST(T_While, yypvt[-3], yypvt[-1]);} break;
case 48:
# line 187 "parser.y"
{yyval = New_AST(ITERS, yypvt[-0], ANULL);} break;
case 49:
# line 189 "parser.y"
{yyval = New_AST(ITERS, yypvt[-2], yypvt[-0]);} break;
case 50:
# line 194 "parser.y"
{yyval = Spread(yypvt[-2], yypvt[-0]);} break;
case 51:
# line 196 "parser.y"
{yyval = Spread(yypvt[-0], ANULL);} break;
case 52:
# line 201 "parser.y"
{yyval = New_AST(T_In, yypvt[-2], yypvt[-0]);} break;
case 53:
# line 203 "parser.y"
{yyval = New_AST(MAP, yypvt[-2], yypvt[-0]);} break;
case 54:
# line 209 "parser.y"
{yyval = New_AST('{', yypvt[-1], ANULL);} break;
case 55:
# line 211 "parser.y"
{yyval = New_AST('(', yypvt[-1], ANULL);} break;
case 56:
# line 214 "parser.y"
{yyval = New_AST(T_Dotdot, yypvt[-2], ANULL);} break;
case 57:
# line 216 "parser.y"
{yyval = New_AST(T_Dotdot, ANULL, yypvt[-1]);} break;
case 58:
# line 218 "parser.y"
{yyval = New_AST(T_Dotdot, yypvt[-3], yypvt[-1]);} break;
case 59:
# line 220 "parser.y"
{yyval = New_AST(CALL, ANULL, ANULL);} break;
case 60:
# line 225 "parser.y"
{yyval = New_AST(T_Gets, yypvt[-2], yypvt[-0]);} break;
case 63:
# line 233 "parser.y"
{yyval = New_AST(T_Missing, ANULL, ANULL);} break;
case 64:
# line 235 "parser.y"
{yyval = New_AST(T_Integer, (AST_Ptr)str((char*)yypvt[-0]),
					   ANULL);} break;
case 65:
# line 237 "parser.y"
{yyval = New_AST(T_Real,    (AST_Ptr)str((char*)yypvt[-0]),
					   ANULL);} break;
case 66:
# line 239 "parser.y"
{yyval = New_AST(T_String,  (AST_Ptr)str((char*)yypvt[-0]),
					   ANULL);} break;
case 67:
# line 242 "parser.y"
{yyval = New_AST(T_True,  ANULL, ANULL);} break;
case 68:
# line 243 "parser.y"
{yyval = New_AST(T_False, ANULL, ANULL);} break;
case 69:
# line 244 "parser.y"
{yyval = New_AST(T_Om,    ANULL, ANULL);} break;
case 70:
# line 245 "parser.y"
{yyval = New_AST(T_Newat, ANULL, ANULL);} break;
case 73:
# line 251 "parser.y"
{yyval = yypvt[-1];} break;
case 74:
# line 253 "parser.y"
{yyval = New_AST('[', yypvt[-1], ANULL); } break;
case 75:
# line 254 "parser.y"
{yyval = New_AST('{', yypvt[-1], ANULL); } break;
case 76:
# line 256 "parser.y"
{yyval = New_AST(DEREF, yypvt[-0], ANULL); } break;
case 77:
# line 258 "parser.y"
{yyval = New_AST(DEREF, yypvt[-3], yypvt[-1]); } break;
case 78:
# line 260 "parser.y"
{yyval = New_AST('#', yypvt[-0], ANULL); } break;
case 79:
# line 263 "parser.y"
{yyval = New_AST(SELECTOR, yypvt[-1], yypvt[-0]);} break;
case 80:
# line 266 "parser.y"
{yyval = New_AST(SELECTOR, yypvt[-1],
		    New_AST( '(', New_AST(0, yypvt[-0],
					 New_AST(0, yypvt[-3], ANULL)),
				  ANULL) );} break;
case 81:
# line 272 "parser.y"
{yyval = New_AST(SELECTOR, yypvt[-2],
		    New_AST( '(', New_AST(0, yypvt[-0],
					 New_AST(0, yypvt[-5], ANULL)),
				  ANULL) );} break;
case 82:
# line 277 "parser.y"
{yyval = New_AST('?',      yypvt[-2], yypvt[-0]);} break;
case 83:
# line 278 "parser.y"
{yyval = New_AST('@',      yypvt[-2], yypvt[-0]);} break;
case 84:
# line 279 "parser.y"
{yyval = New_AST(T_Exp,    yypvt[-2], yypvt[-0]);} break;
case 85:
# line 280 "parser.y"
{yyval = New_AST(T_Times,  yypvt[-2], yypvt[-0]);} break;
case 86:
# line 281 "parser.y"
{yyval = New_AST(T_Slash,  yypvt[-2], yypvt[-0]);} break;
case 87:
# line 282 "parser.y"
{yyval = New_AST(T_Mod,    yypvt[-2], yypvt[-0]);} break;
case 88:
# line 283 "parser.y"
{yyval = New_AST(T_Div,    yypvt[-2], yypvt[-0]);} break;
case 89:
# line 284 "parser.y"
{yyval = New_AST(T_Plus,   yypvt[-2], yypvt[-0]);} break;
case 90:
# line 285 "parser.y"
{yyval = New_AST(T_Minus,  yypvt[-2], yypvt[-0]);} break;
case 91:
# line 286 "parser.y"
{yyval = New_AST(T_With,   yypvt[-2], yypvt[-0]);} break;
case 92:
# line 287 "parser.y"
{yyval = New_AST(T_Less,   yypvt[-2], yypvt[-0]);} break;
case 93:
# line 288 "parser.y"
{yyval = New_AST(T_Eq,     yypvt[-2], yypvt[-0]);} break;
case 94:
# line 289 "parser.y"
{yyval = New_AST(T_Ne,     yypvt[-2], yypvt[-0]);} break;
case 95:
# line 290 "parser.y"
{yyval = New_AST(T_Lt,     yypvt[-2], yypvt[-0]);} break;
case 96:
# line 291 "parser.y"
{yyval = New_AST(T_Gt,     yypvt[-2], yypvt[-0]);} break;
case 97:
# line 292 "parser.y"
{yyval = New_AST(T_Le,     yypvt[-2], yypvt[-0]);} break;
case 98:
# line 293 "parser.y"
{yyval = New_AST(T_Ge,     yypvt[-2], yypvt[-0]);} break;
case 99:
# line 294 "parser.y"
{yyval = New_AST(T_In,     yypvt[-2], yypvt[-0]);} break;
case 100:
# line 295 "parser.y"
{yyval = New_AST(T_Notin,  yypvt[-2], yypvt[-0]);} break;
case 101:
# line 296 "parser.y"
{yyval = New_AST(T_Subset, yypvt[-2], yypvt[-0]);} break;
case 102:
# line 297 "parser.y"
{yyval = New_AST(T_And,    yypvt[-2], yypvt[-0]);} break;
case 103:
# line 298 "parser.y"
{yyval = New_AST(T_Or,     yypvt[-2], yypvt[-0]);} break;
case 104:
# line 299 "parser.y"
{yyval = New_AST(T_Impl,   yypvt[-2], yypvt[-0]);} break;
case 105:
# line 300 "parser.y"
{yyval = New_AST(T_Iff,    yypvt[-2], yypvt[-0]);} break;
case 106:
# line 303 "parser.y"
{yyval = New_AST(T_Insert, yypvt[-1], New_AST(0, yypvt[-3], yypvt[-0]) );} break;
case 107:
# line 306 "parser.y"
{yyval = New_AST(T_Insert, yypvt[-1], 
		      New_AST(0, ANULL, yypvt[-0]) );} break;
case 108:
# line 310 "parser.y"
{yyval = New_AST(T_Not, ANULL, yypvt[-0]);} break;
case 109:
# line 313 "parser.y"
{yyval = New_AST(T_Plus, ANULL, yypvt[-0]);} break;
case 110:
# line 316 "parser.y"
{yyval = New_AST(T_Minus, ANULL, yypvt[-0]);} break;
case 111:
# line 319 "parser.y"
{yyval = New_AST(T_Exists, yypvt[-2], yypvt[-0]);} break;
case 112:
# line 322 "parser.y"
{yyval = New_AST(T_Choose, yypvt[-2], yypvt[-0]);} break;
case 113:
# line 325 "parser.y"
{yyval = New_AST(T_Forall, yypvt[-2], yypvt[-0]);} break;
case 114:
# line 331 "parser.y"
{yyval = New_AST(0, yypvt[-0], ANULL); } break;
case 115:
# line 334 "parser.y"
{yyval = New_AST(0, yypvt[-0], yypvt[-2]); } break;
case 116:
# line 339 "parser.y"
{yyval = New_AST(0, New_AST(T_Om,ANULL,ANULL),
					 New_AST(0,yypvt[-0], ANULL)); } break;
case 117:
# line 341 "parser.y"
{yyval = New_AST(0,yypvt[-0],New_AST(0,yypvt[-2],ANULL)); } break;
case 118:
# line 344 "parser.y"
{yyval = New_AST(0, New_AST(T_Om,ANULL,ANULL),
			 New_AST(0, yypvt[-0], yypvt[-2])); } break;
case 119:
# line 346 "parser.y"
{yyval = New_AST(0,yypvt[-0],New_AST(0,yypvt[-2],yypvt[-4])); } break;
case 120:
# line 351 "parser.y"
{yyval = New_AST(T_Dotdot, yypvt[-2], yypvt[-0]);} break;
case 121:
# line 356 "parser.y"
{yyval= New_AST(T_Frome, yypvt[-2], yypvt[-0]);} break;
case 122:
# line 357 "parser.y"
{yyval= New_AST(T_Fromb, yypvt[-2], yypvt[-0]);} break;
case 123:
# line 358 "parser.y"
{yyval= New_AST(T_From,  yypvt[-2], yypvt[-0]);} break;
case 124:
# line 362 "parser.y"
{yyval = ANULL;} break;
case 125:
# line 363 "parser.y"
{yyval = New_AST(T_St, yypvt[-2], yypvt[-0]);} break;
case 128:
# line 368 "parser.y"
{ yyval = New_AST((int)yyval, ANULL,ANULL); } break;
case 130:
# line 370 "parser.y"
{yyval = yypvt[-0];} break;
case 131:
# line 371 "parser.y"
{yyval = New_AST('(',	yypvt[-1],    ANULL);} break;
case 132:
# line 372 "parser.y"
{yyval = New_AST('(',	yypvt[-1],    ANULL);} break;
case 154:
# line 402 "parser.y"
{yyval=(YYSTYPE)T_Func;} break;
case 155:
# line 402 "parser.y"
{yyval=(YYSTYPE)T_Proc;} break;
case 156:
# line 404 "parser.y"
{yyval=(YYSTYPE)T_End; /* presumes |ptr| >= |int| */} break;
case 157:
# line 405 "parser.y"
{yyval = yypvt[-0];} break;
case 158:
# line 411 "parser.y"
{ yyval = make_func(yypvt[-3],yypvt[-2],yypvt[-1],yypvt[-0]); } break;
case 159:
# line 414 "parser.y"
{ yyval = New_AST(T_Source, Source_List,ANULL); Source_List = yyval;
          if( func_level == 0 ) {
	      Func_Tail = Func_List = mcCons(Nil,Nil);
          }
	  func_level++;
        } break;
case 160:
# line 421 "parser.y"
{ yyval = New_AST(0,yypvt[-2],yypvt[-1]); } break;
case 161:
# line 423 "parser.y"
{ func_level --;
	      if( func_level==0 ) Source_Flush();

	      yyval = New_AST(T_Func, 
		     New_AST(T_Source,
			     (func_level==0 ? Func_List : Nil),
			     ast_2(yypvt[-2])), /* ARGS */
		     New_AST(0, ANULL, /* DCLS */
			     New_AST(0, 
				     yypvt[-5], /* First line */
				     New_AST(0, New_AST(T_Return, yypvt[-1], ANULL),
					     ANULL))));
	      if(func_level==0) {
		  Func_List = Nil;
	      }
	    } break;
case 162:
# line 441 "parser.y"
{ yyval = New_AST(0,yypvt[-1],yypvt[-0]); } break;
case 163:
# line 442 "parser.y"
{ yyval = New_AST(0,ANULL,yypvt[-0]); } break;
case 164:
# line 447 "parser.y"
{ yyval = New_AST(T_Source, Source_List,ANULL); Source_List = yyval;
          if( func_level == 0 ) {
	      Func_Tail = Func_List = mcCons(Nil,Nil);
          }
	  func_level++;
        } break;
case 165:
# line 454 "parser.y"
{ yyval = New_AST((int)yypvt[-5],yypvt[-4],yypvt[-2]); /* presumes |ptr| >= |int| */ } break;
case 166:
# line 458 "parser.y"
{ yyval = ANULL; } break;
case 167:
# line 459 "parser.y"
{ yyval = yypvt[-0]; } break;
case 168:
# line 463 "parser.y"
{ yyval = ANULL; } break;
case 169:
# line 464 "parser.y"
{ yyval = New_AST(T_Local, yypvt[-2], yypvt[-0]); } break;
case 170:
# line 465 "parser.y"
{ yyval = New_AST(T_Value, yypvt[-2], yypvt[-0]); } break;
case 171:
# line 469 "parser.y"
{ yyval = New_AST(0, yypvt[-0], ANULL); } break;
case 172:
# line 470 "parser.y"
{ yyval = New_AST(0, yypvt[-2], yypvt[-0]  ); } break;
case 174:
# line 478 "parser.y"
{ yyval = New_AST(T_Where, yypvt[-3], yypvt[-1]); } break;
case 175:
# line 482 "parser.y"
{ yyval = New_AST(0, yypvt[-0], ANULL); } break;
case 176:
# line 483 "parser.y"
{ yyval = New_AST(0, yypvt[-1], ANULL); } break;
case 177:
# line 484 "parser.y"
{ yyval = New_AST(0, yypvt[-2], yypvt[-0]); } break;
case 178:
# line 489 "parser.y"
{ yyval = New_AST( T_Gets, yypvt[-2],yypvt[-0]); } break;
case 179:
# line 491 "parser.y"
{ yyval = New_AST(SELECTOR, New_AST(SELECTOR, yypvt[-3], yypvt[-2]), yypvt[-0]); } break;
case 180:
# line 495 "parser.y"
{yyval = New_AST(T_Missing, ANULL, ANULL);} break;
case 182:
# line 497 "parser.y"
{yyval = New_AST('[', yypvt[-1], ANULL); } break;
case 183:
# line 501 "parser.y"
{ yyval = New_AST(0, yypvt[-0], ANULL); } break;
case 184:
# line 502 "parser.y"
{ yyval = New_AST(0, yypvt[-0], yypvt[-2]); } break;
	}
	goto yystack;		/* reset registers in driver code */
}
